Wt: Wt::WPaintedWidget Class Reference

Wt 4.10.4

Loading...
Searching...
No Matches
Public Member Functions | Protected Member Functions | List of all members
Wt::WPaintedWidget Class Referenceabstract
Painting system

A widget that is painted using vector graphics. More...

`#include <Wt/WPaintedWidget.h>`

Inheritance diagram for Wt::WPaintedWidget:
[legend]

## Public Member Functions
| WPaintedWidget ()
| Create a new painted widget.
| ~WPaintedWidget ()
| Destructor.
void | setPreferredMethod (RenderMethod method)
| Sets the preferred rendering method.
RenderMethod | preferredMethod () const
| Returns the preferred rendering method.
void | update (WFlags< PaintFlag > flags=None)
| Lets the widget repaint itself.
virtual void | resize (const WLength &width, const WLength &height) override
| Resizes the widget.
void | addArea (std::unique_ptr< WAbstractArea > area)
| Adds an interactive area.
void | insertArea (int index, std::unique_ptr< WAbstractArea > area)
| Inserts an interactive area.
std::unique_ptr< WAbstractArea > | removeArea (WAbstractArea *area)
| Removes an interactive area.
WAbstractArea * | area (int index) const
| Returns the interactive area at the given index.
const std::vector< WAbstractArea * > | areas () const
| Returns the interactive areas set for this widget.
JSlot & | repaintSlot ()
| A JavaScript slot that repaints the widget when triggered.
Public Member Functions inherited from Wt::WInteractWidget
| WInteractWidget ()
| Create an InteractWidget.
EventSignal< WKeyEvent > & | keyWentDown ()
| Event signal emitted when a keyboard key is pushed down.
EventSignal< WKeyEvent > & | keyPressed ()
| Event signal emitted when a "character" was entered.
EventSignal< WKeyEvent > & | keyWentUp ()
| Event signal emitted when a keyboard key is released.
EventSignal & | enterPressed ()
| Event signal emitted when enter was pressed.
EventSignal & | escapePressed ()
| Event signal emitted when escape was pressed.
EventSignal< WMouseEvent > & | clicked ()
| Event signal emitted when the primary mouse button was clicked on this widget.
EventSignal< WMouseEvent > & | doubleClicked ()
| Event signal emitted when the primary mouse button was double clicked on this widget.
EventSignal< WMouseEvent > & | mouseWentDown ()
| Event signal emitted when a mouse button was pushed down on this widget.
EventSignal< WMouseEvent > & | mouseWentUp ()
| Event signal emitted when a mouse button was released on this widget.
EventSignal< WMouseEvent > & | mouseWentOut ()
| Event signal emitted when the mouse went out of this widget.
EventSignal< WMouseEvent > & | mouseWentOver ()
| Event signal emitted when the mouse entered this widget.
EventSignal< WMouseEvent > & | mouseMoved ()
| Event signal emitted when the mouse moved over this widget.
EventSignal< WMouseEvent > & | mouseDragged ()
| Event signal emitted when the mouse is dragged over this widget.
EventSignal< WMouseEvent > & | mouseWheel ()
| Event signal emitted when the mouse scroll wheel was used.
EventSignal< WTouchEvent > & | touchStarted ()
| Event signal emitted when a finger is placed on the screen.
EventSignal< WTouchEvent > & | touchEnded ()
| Event signal emitted when a finger is removed from the screen.
EventSignal< WTouchEvent > & | touchMoved ()
| Event signal emitted when a finger, which is already placed on the screen, is moved across the screen.
EventSignal< WGestureEvent > & | gestureStarted ()
| Event signal emitted when a gesture is started.
EventSignal< WGestureEvent > & | gestureChanged ()
| Event signal emitted when a gesture is changed.
EventSignal< WGestureEvent > & | gestureEnded ()
| Event signal emitted when a gesture is ended.
void | setDraggable (const std::string &mimeType, WWidget *dragWidget=nullptr, bool isDragWidgetOnly=false, WObject *sourceWidget=nullptr)
| Configure dragging for drag and drop.
void | unsetDraggable ()
| Disable drag & drop for this widget.
void | setMouseOverDelay (int delay)
| Sets a delay for the mouse over event.
int | mouseOverDelay () const
| Returns the mouse over signal delay.
virtual void | setPopup (bool popup) override
| Lets the widget overlay over other sibling widgets.
virtual void | load () override
| Loads content just before the widget is used.
virtual bool | isEnabled () const override
| Returns whether the widget is enabled.
Public Member Functions inherited from Wt::WWebWidget
| WWebWidget ()
| Construct a WebWidget.
virtual std::vector< WWidget * > | children () const override
| Returns child widgets.
Signal & | childrenChanged ()
| Signal emitted when children have been added or removed.
virtual void | setPositionScheme (PositionScheme scheme) override
| Sets the CSS position scheme.
virtual PositionScheme | positionScheme () const override
| Returns the CSS position scheme.
virtual void | setOffsets (const WLength &offset, WFlags< Side > sides=AllSides) override
| Sets CSS offsets for a non-statically positioned widget.
virtual WLength | offset (Side s) const override
| Returns a CSS offset.
virtual WLength | width () const override
| Returns the width.
virtual WLength | height () const override
| Returns the height.
virtual void | setMinimumSize (const WLength &width, const WLength &height) override
| Sets a minimum size.
virtual WLength | minimumWidth () const override
| Returns the minimum width.
virtual WLength | minimumHeight () const override
| Returns the minimum height.
virtual void | setMaximumSize (const WLength &width, const WLength &height) override
| Sets a maximum size.
virtual WLength | maximumWidth () const override
| Returns the maximum width.
virtual WLength | maximumHeight () const override
| Returns the maximum height.
virtual void | setLineHeight (const WLength &height) override
| Sets the CSS line height for contained text.
virtual WLength | lineHeight () const override
| Returns the CSS line height for contained text.
virtual void | setFloatSide (Side s) override
| Specifies a CSS float side.
virtual Side | floatSide () const override
| Returns the CSS float side.
virtual void | setClearSides (WFlags< Side > sides) override
| Sets the sides that should be cleared of floats.
virtual WFlags< Side > | clearSides () const override
| Returns the sides that should remain empty.
virtual void | setMargin (const WLength &margin, WFlags< Side > sides=AllSides) override
| Sets CSS margins around the widget.
virtual WLength | margin (Side side) const override
| Returns a CSS margin set.
virtual void | setHiddenKeepsGeometry (bool enabled) override
| Sets whether the widget keeps its geometry when hidden.
virtual bool | hiddenKeepsGeometry () const override
| Returns whether the widget keeps its geometry when hidden.
virtual void | setHidden (bool hidden, const WAnimation &animation=WAnimation()) override
| Hides or shows the widget.
virtual bool | isHidden () const override
| Returns whether the widget is set hidden.
virtual bool | isVisible () const override
| Returns whether the widget is visible.
virtual void | setDisabled (bool disabled) override
| Sets whether the widget is disabled.
virtual bool | isDisabled () const override
| Returns whether the widget is set disabled.
virtual bool | isPopup () const override
| Returns whether the widget is overlayed.
virtual void | setInline (bool isInline) override
| Sets whether the widget is displayed inline or as a block.
virtual bool | isInline () const override
| Returns whether the widget is displayed inline or as block.
virtual void | setDecorationStyle (const WCssDecorationStyle &style) override
| Sets a CSS decoration style.
virtual WCssDecorationStyle & | decorationStyle () override
| Returns the decoration style of this widget.
virtual void | setStyleClass (const WString &styleClass) override
| Sets (one or more) CSS style classes.
virtual WString | styleClass () const override
| Returns the CSS style class.
virtual void | addStyleClass (const WString &styleClass, bool force=false) override
| Adds a CSS style class.
virtual void | removeStyleClass (const WString &styleClass, bool force=false) override
| Removes a CSS style class.
virtual bool | hasStyleClass (const WString &styleClass) const override
| Returns whether the widget has a style class.
virtual void | setVerticalAlignment (AlignmentFlag alignment, const WLength &length=WLength()) override
| Sets the vertical alignment.
virtual AlignmentFlag | verticalAlignment () const override
| Returns the vertical alignment.
virtual WLength | verticalAlignmentLength () const override
| Returns the fixed vertical alignment that was set.
virtual void | setToolTip (const WString &text, TextFormat textFormat=TextFormat::Plain) override
| Sets a tooltip.
virtual void | setDeferredToolTip (bool enable, TextFormat textFormat=TextFormat::Plain) override
| Enable deferred tooltip.
virtual WString | toolTip () const override
| Returns the tooltip.
virtual void | refresh () override
| Refresh the widget.
virtual void | setAttributeValue (const std::string &name, const WString &value) override
| Sets an attribute value.
virtual WString | attributeValue (const std::string &name) const override
| Returns an attribute value.
virtual void | setJavaScriptMember (const std::string &name, const std::string &value) override
| Sets a JavaScript member.
virtual std::string | javaScriptMember (const std::string &name) const override
| Returns the value of a JavaScript member.
virtual void | callJavaScriptMember (const std::string &name, const std::string &args) override
| Calls a JavaScript member.
virtual bool | loaded () const override
| Returns whether this widget has been loaded.
virtual void | setId (const std::string &id) override
| Sets the CSS Id.
virtual WWidget * | find (const std::string &name) override
| Finds a descendent widget by name.
virtual WWidget * | findById (const std::string &id) override
| Finds a descendent widget by id.
virtual void | setSelectable (bool selectable) override
| Sets as selectable.
virtual void | doJavaScript (const std::string &javascript) override
| Executes the given JavaScript statements when the widget is rendered or updated.
virtual const std::string | id () const override
| Returns the (unique) identifier for this object.
void | setLoadLaterWhenInvisible (bool)
| Change the way the widget is loaded when invisible.
std::string | htmlTagName () const
| returns the current html tag name
void | setHtmlTagName (const std::string &tag)
| set the custom HTML tag name
virtual void | setCanReceiveFocus (bool enabled) override
| Sets whether the widget can receive focus.
virtual bool | canReceiveFocus () const override
| Returns whether the widget can receive focus.
virtual bool | setFirstFocus () override
| Set focus on the widget's first descendant.
virtual void | setFocus (bool focus) override
| Sets focus.
virtual bool | hasFocus () const override
| Returns whether the widget currently has the focus.
virtual void | setTabIndex (int index) override
| Sets the tab index.
virtual int | tabIndex () const override
| Returns the tab index.
EventSignal & | blurred ()
| Signal emitted when the widget lost focus.
EventSignal & | focussed ()
| Signal emitted when the widget recieved focus.
virtual bool | scrollVisibilityEnabled () const final override
| Returns whether scroll visibility detection is enabled for this widget.
virtual void | setScrollVisibilityEnabled (bool enabled) final override
| Sets whether scroll visibility detection is enabled for this widget.
virtual int | scrollVisibilityMargin () const final override
| Returns the margin around the viewport within which the widget is considered visible.
virtual void | setScrollVisibilityMargin (int margin) final override
| Sets the margin around the viewport within which the widget is considered visible.
virtual Signal< bool > & | scrollVisibilityChanged () final override
| Signal triggered when the scroll visibility of this widget changes.
virtual bool | isScrollVisible () const final override
| Returns whether this widget is currently considered scroll visible.
virtual void | setThemeStyleEnabled (bool enabled) final override
| Sets whether theme styling for a widget is enabled or disabled.
virtual bool | isThemeStyleEnabled () const final override
| Returns whether this widget is currently styled by the chosen theme.
virtual void | setObjectName (const std::string &name) override
| Sets an object name.
void | setFocus ()
| Sets focus.
Public Member Functions inherited from Wt::WWidget
virtual | ~WWidget ()
| Destructor.
WWidget * | parent () const
| Returns the parent widget.
virtual std::unique_ptr< WWidget > | removeWidget (WWidget *widget)
| Removes a child widget.
template<typename Widget >
std::unique_ptr< Widget > | removeWidget (Widget *widget)
| Removes a child widget.
std::unique_ptr< WWidget > | removeFromParent ()
| Removes the widget from its parent.
void | setWidth (const WLength &width)
| Sets the width.
void | setHeight (const WLength &height)
| Sets the height.
virtual void | positionAt (const WWidget *widget, Orientation orientation=Orientation::Vertical)
| Positions a widget next to another widget.
virtual void | toggleStyleClass (const WString &styleClass, bool add, bool force=false)
| Toggles a CSS style class.
std::string | jsRef () const
| Returns a JavaScript expression to the corresponding DOM node.
void | setFocus ()
| Sets focus.
virtual void | acceptDrops (const std::string &mimeType, const WString &hoverStyleClass=WString())
| Sets a mime type to be accepted for dropping.
virtual void | stopAcceptDrops (const std::string &mimeType)
| Indicates that a mime type is no longer accepted for dropping.
virtual void | htmlText (std::ostream &out)
| Streams the (X)HTML representation.
bool | isRendered () const
| Returns whether the widget is rendered.
void | hide ()
| Hides the widget.
void | animateHide (const WAnimation &animation)
| Hides the widget using an animation.
void | show ()
| Shows the widget.
void | animateShow (const WAnimation &animation)
| Shows the widget using an animation.
void | enable ()
| Enables the widget.
void | disable ()
| Disable thes widget.
bool | layoutSizeAware () const
| Returns whether the widget is layout size aware.
Public Member Functions inherited from Wt::WObject
void | addChild (std::unique_ptr< WObject > child)
| Add a child WObject whose lifetime is determined by this WObject.
template<typename Child >
Child * | addChild (std::unique_ptr< Child > child)
| Add a child WObject, returning a raw pointer.
std::unique_ptr< WObject > | removeChild (WObject *child)
| Remove a child WObject, so its lifetime is no longer determined by this WObject.
template<typename Child >
std::unique_ptr< Child > | removeChild (Child *child)
| Remove a child WObject, so its lifetime is no longer determined by this WObject.
virtual std::string | objectName () const
| Returns the object name.
void | resetLearnedSlots ()
| Resets learned stateless slot implementations.
template<class T >
void | resetLearnedSlot (void(T::*method)())
| Resets a learned stateless slot implementation.
template<class T >
WStatelessSlot * | implementStateless (void(T::*method)())
| Declares a slot to be stateless and learn client-side behaviour on first invocation.
template<class T >
WStatelessSlot * | implementStateless (void(T::*method)(), void(T::*undoMethod)())
| Declares a slot to be stateless and learn client-side behaviour in advance.
void | isNotStateless ()
| Marks the current function as not stateless.
template<class T >
WStatelessSlot * | implementJavaScript (void(T::*method)(), const std::string &jsCode)
| Provides a JavaScript implementation for a method.
Public Member Functions inherited from Wt::Core::observable
| observable () noexcept
| Default constructor.
virtual | ~observable ()
| Destructor.
template<typename... Args, typename C >
auto | bindSafe (void(C::*method)(Args...)) noexcept
| Protects a method call against object destruction.
template<typename... Args, typename C >
auto | bindSafe (void(C::*method)(Args...) const) const noexcept
| Protects a const method call against object destruction.
template<typename Function >
auto | bindSafe (const Function &function) noexcept
| Protects a function against object destruction.

## Protected Member Functions
WJavaScriptHandle< WTransform > | createJSTransform ()
| Create a WTransform that is accessible from JavaScript, associated with this WPaintedWidget.
WJavaScriptHandle< WBrush > | createJSBrush ()
| Create a WBrush that is accessible from JavaScript, associated with this WPaintedWidget.
WJavaScriptHandle< WPen > | createJSPen ()
| Create a WPen that is accessible from JavaScript, associated with this WPaintedWidget.
WJavaScriptHandle< WPainterPath > | createJSPainterPath ()
| Create a WPainterPath that is accessible from JavaScript, associated with this WPaintedWidget.
WJavaScriptHandle< WRectF > | createJSRect ()
| Create a WRectF that is accessible from JavaScript, associated with this WPaintedWidget.
WJavaScriptHandle< WPointF > | createJSPoint ()
| Create a WPointF that is accessible from JavaScript, associated with this WPaintedWidget.
virtual void | layoutSizeChanged (int width, int height) override
| Virtual method that indicates a size change.
virtual RenderMethod | getMethod () const
| Returns the actual method used for rendering.
virtual void | paintEvent (WPaintDevice *paintDevice)=0
| Paints the widget.
virtual std::unique_ptr< WPaintDevice > | createPaintDevice () const
| Creates a paint device.
virtual void | enableAjax () override
| Progresses to an Ajax-enabled widget.
virtual void | render (WFlags< RenderFlag > flags) override
| Renders the widget.
std::string | objJsRef () const
| Returns a JavaScript reference to the client side representation of the WPaintedWidget.
Protected Member Functions inherited from Wt::WInteractWidget
virtual void | propagateSetEnabled (bool enabled) override
| Propagates that a widget was enabled or disabled through children.
Protected Member Functions inherited from Wt::WWebWidget
virtual WStatelessSlot * | getStateless (Method method) override
| On-demand stateless slot implementation.
Protected Member Functions inherited from Wt::WWidget
void | setLayoutSizeAware (bool sizeAware)
| Sets the widget to be aware of its size set by a layout manager.
| WWidget ()
| Creates a widget.
virtual void | dropEvent (WDropEvent dropEvent)
| Handles a drop event.
virtual int | boxPadding (Orientation orientation) const
| Returns the widget's built-in padding.
virtual int | boxBorder (Orientation orientation) const
| Returns the widget's built-in border width.
void | scheduleRender (WFlags< RepaintFlag > flags=None)
| Schedules rerendering of the widget.
Protected Member Functions inherited from Wt::WObject

## Additional Inherited Members
Public Types inherited from Wt::WObject
typedef void(WObject::*) | Method()
| Typedef for a WObject method without arguments.
Static Public Member Functions inherited from Wt::WWebWidget
static std::string | jsStringLiteral (const std::string &v, char delimiter='\'')
| Turn a CharEncoding::UTF8 encoded string into a JavaScript string literal.
Static Public Member Functions inherited from Wt::WWidget
static WString | tr (const char *key)
| Short hand for WString::tr()
Static Public Member Functions inherited from Wt::WObject
Static Public Attributes inherited from Wt::WWidget
Protected Types inherited from Wt::WWebWidget
Protected Types inherited from Wt::WWidget
Protected Attributes inherited from Wt::WInteractWidget
Static Protected Attributes inherited from Wt::WInteractWidget
Static Protected Attributes inherited from Wt::WWidget

## Detailed Description

A widget that is painted using vector graphics.

A painted widget is rendered from basic drawing primitives. Rendering is done not on the server but on the browser, using different rendering methods:

Browser | Methods | Default method
Firefox 1.5+ | HtmlCanvas, InlineSVG, PngImage | HtmlCanvas
Internet Explorer 6.0+ | InlineVML, PngImage | InlineVML
Internet Explorer 9+ | HtmlCanvas, InlineSVG, PngImage | HtmlCanvas
Safari | HtmlCanvas, InlineSVG, PngImage | HtmlCanvas
Opera | InlineSVG, HtmlCanvas*, PngImage | InlineSVG
other | ? | HtmlCanvas, PngImage

* HtmlCanvas occasionally suffers from rendering artefacts in Opera.

The different rendering methods correspond to different WPaintDevice implementations, from which this widget choses a suitable one depending on the browser capabilities and configuration.

If no JavaScript is available, the JavaScript-based HtmlCanvas will not be used, and InlineSVG will be used instead. The method used may be changed by using setPreferredMethod().

In some browsers, InlineSVG requires that the document is rendered as XHTML. This must be enabled in the configuration file using the `<send-xhtml-mime-type>` option. By default, this option is off. Firefox 4 and Chrome do support svg in normal html mode.

The PngImage is the most portable rendering method, and may be the fastest if the painting is of high complexity and/or the image is fairly small.

To use a WPaintedWidget, you must derive from it and reimplement paintEvent(WPaintDevice *paintDevice). To paint on a WPaintDevice, you will need to use a WPainter. Repainting is triggered by calling the update() method.

Usage example:

class MyPaintedWidget : public Wt::WPaintedWidget
{
public:
MyPaintedWidget()
: Wt::WPaintedWidget()
foo_(100)
{
resize(200, 200); // provide a default size
}
void setFoo(int foo) {
foo_ = foo;
update(); // trigger a repaint
}
protected:
void paintEvent(Wt::WPaintDevice *paintDevice) {
Wt::WPainter painter(paintDevice);
painter.drawLine(20, 20, foo_, foo_);
...
}
private:
int foo_;
};
Wt::WPaintDevice
The abstract base class for a paint device.
Definition WPaintDevice.h:105
Wt::WPaintedWidget
A widget that is painted using vector graphics.
Definition WPaintedWidget.h:142
Wt::WPaintedWidget::resize
virtual void resize(const WLength &width, const WLength &height) override
Resizes the widget.
Wt::WPaintedWidget::update
void update(WFlags< PaintFlag > flags=None)
Lets the widget repaint itself.
Wt::WPaintedWidget::paintEvent
virtual void paintEvent(WPaintDevice *paintDevice)=0
Paints the widget.
Wt::WPainter
Vector graphics painting class.
Definition WPainter.h:147
Wt
The namespace for Wt.
Definition strand.hpp:29

### CSS

Styling through CSS is not applicable.

Note
  A WPaintedWidget requires that it is given a size using resize() or by a layout manager.

### Client side interaction and repainting

If the widget is drawn as an HTML canvas element, i.e. the method is HtmlCanvas, a WPaintedWidget can expose certain objects to be modified client side.

See also
  WJavaScriptHandle, WJavaScriptExposableObject
  WImage

## Member Function Documentation

## ◆ addArea()

void Wt::WPaintedWidget::addArea | ( | std::unique_ptr< WAbstractArea > | area | ) |

Adds an interactive area.

Adds the `area` which listens to events in a specific region of the widget. Areas are organized in a list, to which the given `area` is appended. When areas overlap, the area with the lowest index receives the event.

Note
  When defining at least one area, no more events will propagate to the widget itself. As a work-around, you can emulate this by listening for events on a WRectArea that corresponds to the whole widget, and which is added as the last area (catching all events that were not caught by preceding areas).

See also
  insertArea(int, WAbstractArea *)

## ◆ area()

WAbstractArea * Wt::WPaintedWidget::area | ( | int | index | ) | const

Returns the interactive area at the given index.

Returns `0` if `index` was invalid.

See also
  insertArea(int, WAbstractArea *)

## ◆ areas()

const std::vector< WAbstractArea * > Wt::WPaintedWidget::areas | ( |  | ) | const

Returns the interactive areas set for this widget.

See also
  addArea()

## ◆ createPaintDevice()

virtual std::unique_ptr< WPaintDevice > Wt::WPaintedWidget::createPaintDevice | ( |  | ) | const
| protectedvirtual

Creates a paint device.

Although it's usually not necessary to call this function, you may want to reimplement this function to customize or specialize the device used for painting the widget.

## ◆ enableAjax()

virtual void Wt::WPaintedWidget::enableAjax | ( |  | ) |
| overrideprotectedvirtual

Progresses to an Ajax-enabled widget.

This method is called when the progressive bootstrap method is used, and support for AJAX has been detected. The default behavior will upgrade the widget's event handling to use AJAX instead of full page reloads, and propagate the call to its children.

You may want to reimplement this method if you want to make changes to widget when AJAX is enabled. You should always call the base implementation.

See also
  WApplication::enableAjax()

Reimplemented from Wt::WWebWidget.

## ◆ getMethod()

virtual RenderMethod Wt::WPaintedWidget::getMethod | ( |  | ) | const
| protectedvirtual

Returns the actual method used for rendering.

The default method considers browser capabilites and the preferred method to make an actual choice for the implementation.

You may want to reimplement this method to override this choice.

## ◆ insertArea()

void Wt::WPaintedWidget::insertArea | ( | int | index,
|  | std::unique_ptr< WAbstractArea > | area )

Inserts an interactive area.

Inserts the `area` which listens to events in the coresponding area of the widget. Areas are organized in a list, and the area is inserted at index `index`. When areas overlap, the area with the lowest index receives the event.

Note
  When defining at least one area, no more events will propagate to the widget itself. As a work-around, you can emulate this by listening for events on a WRectArea that corresponds to the whole widget, and which is added as the last area (catching all events that were not caught by preceding areas).

See also
  addArea(WAbstractArea *)

## ◆ layoutSizeChanged()

virtual void Wt::WPaintedWidget::layoutSizeChanged | ( | int | width,
|  | int | height )
| overrideprotectedvirtual

Virtual method that indicates a size change.

This method propagates the client-side width and height of the widget when the widget is contained by a layout manager and setLayoutSizeAware(true) was called.

See also
  setLayoutSizeAware()

Reimplemented from Wt::WWidget.

## ◆ objJsRef()

std::string Wt::WPaintedWidget::objJsRef | ( |  | ) | const
| protected

Returns a JavaScript reference to the client side representation of the WPaintedWidget.

The client side representation exposes the following interface:

{
canvas: exposes the underlying HTML canvas element
repaint: a function that, when called, will repaint the widget without a server roundtrip
}

Note
  The method should be HtmlCanvas and there has to be at least one WJavaScriptHandle associated with this WPaintedWidget in order for this reference to be valid.

## ◆ paintEvent()

virtual void Wt::WPaintedWidget::paintEvent | ( | WPaintDevice * | paintDevice | ) |
| protectedpure virtual

Paints the widget.

You should reimplement this method to paint the contents of the widget, using the given paintDevice.

Implemented in Wt::Chart::WAxisSliderWidget, Wt::Chart::WCartesianChart, and Wt::Chart::WPieChart.

## ◆ preferredMethod()

RenderMethod Wt::WPaintedWidget::preferredMethod | ( |  | ) | const

Returns the preferred rendering method.

See also
  setPreferredMethod(Method)

## ◆ removeArea()

std::unique_ptr< WAbstractArea > Wt::WPaintedWidget::removeArea | ( | WAbstractArea * | area | ) |

Removes an interactive area.

Removes the `area` from this widget.

See also
  addArea(WAbstractArea *)

## ◆ render()

virtual void Wt::WPaintedWidget::render | ( | WFlags< RenderFlag > | flags | ) |
| overrideprotectedvirtual

Renders the widget.

This function renders the widget (or an update for the widget), after this has been scheduled using scheduleRender().

The default implementation will render the widget by serializing changes to JavaScript and HTML. You may want to reimplement this widget if you have been postponing some of the layout / rendering implementation until the latest moment possible. In that case you should make sure you call the base implementation however.

Reimplemented from Wt::WWebWidget.

Reimplemented in Wt::Chart::WAxisSliderWidget, and Wt::Chart::WCartesianChart.

## ◆ repaintSlot()

JSlot & Wt::WPaintedWidget::repaintSlot | ( |  | ) |

A JavaScript slot that repaints the widget when triggered.

This is useful for client-side initiated repaints. You may want to use this if you want to add interaction or animation to your WPaintedWidget.

Note
  This feature is currently only supported if the method is HtmlCanvas. This will not cause a server roundtrip. Instead, the resulting JavaScript of paintEvent() will be re-executed on the client side.

See also
  objJsRef()

## ◆ resize()

virtual void Wt::WPaintedWidget::resize | ( | const WLength & | width,
|  | const WLength & | height )
| overridevirtual

Resizes the widget.

Specifies a fixed size for this widget, setting CSS `width` and `height` properties. By default a widget has automatic width and height, which sets a size for the widget following CSS rules.

When the widget is not managed by a layout manager, the automatic (natural) size of a widget depends on whether they widget is a block or inline widget:

- a block widget takes by default the width of the parent, and the height that it needs based on its contents
- an inline widget takes the width and height that it needs based on its contents (possibly wrapping over multiple lines). The width and height of an inline widget cannot be changed (by the letter of CSS, although most browsers will react to it in varying ways).

When inserted in a layout manager, the size set will be used as a widget's preferred size, but the widget may be given a different size by the layout manager based on available space and stretch factors. The actual size given by a layout manager may be retrieved by making the widget "layout size aware", using setLayoutSizeAware(). If you have defined a `"wtResize()"` JavaScript method for the widget, then this method will also be called.

The default width and height of a widget is WLength::Auto.

See also
  width(), height()

Reimplemented from Wt::WWebWidget.

## ◆ setPreferredMethod()

void Wt::WPaintedWidget::setPreferredMethod | ( | RenderMethod | method | ) |

Sets the preferred rendering method.

When `method` is supported by the browser, then it is chosen for rendering.

## ◆ update()

void Wt::WPaintedWidget::update | ( | WFlags< PaintFlag > | flags = None | ) |

Lets the widget repaint itself.

Repainting is not immediate, but happens after when the event loop is exited.

Unless a Wt::PaintFlag::Update paint flag is set, the widget is first cleared.